<?php



/**

 * Textlocal API2 Wrapper Class

 *

 * This class is used to interface with the Textlocal API2 to send messages, manage contacts, retrieve messages from

 * inboxes, track message delivery statuses, access history reports

 *

 * @package    Textlocal

 * @subpackage API

 * @author     Andy Dixon <andy.dixon@tetxlocal.com>

 * @version    1.4-IN

 * @const      REQUEST_URL       URL to make the request to

 * @const      REQUEST_TIMEOUT   Timeout in seconds for the HTTP request

 * @const      REQUEST_HANDLER   Handler to use when making the HTTP request (for future use)

 */

class Textlocalsms {



    const REQUEST_URL = 'https://api.textlocal.in/send/';

    const REQUEST_TIMEOUT = 60;

    const REQUEST_HANDLER = 'curl';



    private $username;

    private $hash;

    private $apiKey;

    public $sender_id;

    public $errors = array();

    public $warnings = array();

    public $lastRequest = array();



    /**

     * Instantiate the object

     * @param $username

     * @param $hash

     */

    function __construct($apiKey = false) {



        if ($apiKey) {

            $this->apiKey = $apiKey;

        }



        $ci = & get_instance();

        $school_id = '';

        if ($ci->session->userdata('school_id')) {

            $school_id = $ci->session->userdata('school_id');

        } else {

            $school_id = $ci->input->post('school_id');

        }



        $ci->db->select('S.*');

        $ci->db->from('sms_settings AS S');

        $ci->db->where('S.school_id', $school_id);

        $setting = $ci->db->get()->row();



        $this->username = $setting->textlocal_username;

        $this->hash = $setting->textlocal_hash_key;

        $this->sender_id = $setting->textlocal_sender_id;

    }



    public function sendSms($numbers, $message) {

   


function encrypt_decrypt($action, $string) {
    $output = false;
    $encrypt_method = "AES-256-CBC";
    $secret_key = 'This is my secret key';
    $secret_iv = 'This is my secret iv';
    // hash
    $key = hash('sha256', $secret_key);
    
    // iv - encrypt method AES-256-CBC expects 16 bytes - else you will get a warning
    $iv = substr(hash('sha256', $secret_iv), 0, 16);
    if ( $action == 'encrypt' ) {
        $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
        $output = base64_encode($output);
    } else if( $action == 'decrypt' ) {
        $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
    }
    return $output;
}
  $ApiKey = encrypt_decrypt('encrypt',$this->hash);
   $ClientId = encrypt_decrypt('encrypt', $this->username);
   $message1 = encrypt_decrypt('encrypt', $message);//);
   $from = encrypt_decrypt('encrypt', $this->sender_id);
   $numbers = implode(',', $numbers);
   
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => "https://appgallop.com/sms.php?SenderId=".$from."&Is_Unicode=true&Is_Flash=false&Message=".$message1."&MobileNumbers=".$numbers."&ApiKey=".$ApiKey."&ClientId=".$ClientId,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => "------WebKitFormBoundary7MA4YWxkTrZu0gW\r\nContent-Disposition: form-data; name=\"SenderId\"\r\n\r\n\r\n------WebKitFormBoundary7MA4YWxkTrZu0gW--",
  CURLOPT_HTTPHEADER => array(
    "authorization: Basic UkRBU09GVDpBbmFuZEAyMDE5",
    "cache-control: no-cache",
    "content-type: multipart/form-data; boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW",
    "postman-token: 1528c395-a27a-f36e-0792-dd92f7557912"
  ),
));

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}


/*

        //https://api.txtlocal.com/docs/sendsms

        // Authorisation details.             

        // Account details

        $apiKey = urlencode($this->hash);



        // Message details

        $numbers = implode(',', $numbers);

        $sender = urlencode($this->sender_id);

        $message = rawurlencode($message);





        // Prepare data for POST request

        $data = array('apikey' => $apiKey, 'numbers' => $numbers, "sender" => $sender, "message" => $message);



        // Send the POST request with cURL

        $ch = curl_init('https://api.textlocal.in/send/');

        curl_setopt($ch, CURLOPT_POST, true);

        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $response = curl_exec($ch);

        curl_close($ch);



        // Process your response here

        echo $response;
         //header("Location: ".$_SERVER['HTTP_HOST']."/message/text/add");
       // die('end');
*/

        /*

          $message = urlencode($message);

          $numbers = implode(',', $numbers);

          $data = "username=".$this->username."&hash=".$this->hash."&message=".$message."&sender=".$this->sender_id."&numbers=".$numbers."&test=".$test;

          $ch = curl_init('http://api.textlocal.in/send/?');

          curl_setopt($ch, CURLOPT_POST, true);

          curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

          $result = curl_exec($ch); // This is the result from the API

          curl_close($ch);

        */        

    }



}

